var moviePlayer;
var rect;

function moviePlayer_open(json) {
    console.log('moviePlayer_open:' + jsonToStr(json));
    // api.setFullScreen({fullScreen: false,});
    if (is_null(moviePlayer)) {

        moviePlayer = api.require('moviePlayer');
        moviePlayer.open({
            rect: {
                x: json.x,   //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
                y: json.y,   //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
                w: json.w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
                h: json.h,  //（可选项）数字类型；模块的高度；默认：w的3/4

            },
            texts: {
                title: json.title//（可选项）字符串类型；顶部标题文字
            },
            styles: {
                head: {//（可选项）JSON对象；播放器顶部导航条样式
                    bg: 'rgba(0,0,0,0)', //（可选项）字符串类型；顶部导航条背景，支持#、rgb、rgba、img；默认：rgba(161,161,161,0.5)
                    height: 0,                  //（可选项）数字类型；顶部导航条的高；默认：44
                    // y: 0,                        // (可选项）数字类型；距离模块顶部的距离；默认：20
                    title: {
                        // size: 20,                     //（可选项）数字类型；顶部标题字体大小；默认：20
                        color: '#fff',                //（可选项）字符串类型；顶部标题字体颜色；默认：#fff
                        // width: 0,                    //(可选项)标题的宽度，文本超过该宽度，显示...
                        // leftMargin: 0,                //（可选项）距离左边控件的外边距，默认：10
                    },
                    backSize: 0,                //（可选项）数字类型；顶部返回按钮大小；默认：44
                    backImg: 'widget://images/Player_img/no_btn.png', //（可选项）字符串类型；顶部返回按钮的背景图片，要求本地路径（widget://、fs://）；默认：返回小箭头图标
                },
                foot: {
                    bg: 'rgba(0,0,0,0.4)',         //（可选项）字符串类型；底部导航条背景，支持#、rgb、rgba、img；默认：rgba(161,161,161,0.5)
                    height: 30,//（可选项）数字类型；底部导航条的高；默认：44
                    palyBtn: {
                        size: 23,                    //（可选项）数字类型；底部播放/暂停按钮大小；默认：44
                        playImg: 'widget://images/Player_img/play.png',  //（可选项）字符串类型；底部播放按钮的背景图片，要求本地路径（widget://、fs://）；默认：播放按钮图标
                        pauseImg: 'widget://images/Player_img/pause.png',//（可选项）字符串类型；底部暂停按钮的背景图片，要求本地路径（widget://、fs://）；默认：暂停按钮图标
                        marginLeft: 5                  // (可选项)数字类型；左边距，默认：5
                    },
                    currentTimeLabel: {
                        textSize: 10,                  //（可选项）数字类型；底部时间标签大小；默认：14
                        textColor: "#FFF",             //（可选项）字符串类型；底部时间标签颜色，支持#、rgba、rgb；默认：#FFF
                        textWidth: 40,                //（可选项） 数字类型；时间标签的宽度
                        marginLeft: 1                  // (可选项)数字类型；左边距，默认：5

                    },
                    seekBar: {
                        sliderImg: 'widget://images/Player_img/slider.png', //（可选项）字符串类型；底部进度条滑块背景图片，要求本地路径（widget://、fs://）；默认：滑块小图标
                        sliderW: 14,      // 数字类型; slider 的宽度
                        sliderH: 14,      // 数字类型; slider 的高度
                        progressColor: '#D8D8D8',          //（可选项）字符串类型；进度条背景色，支持#、rgba、rgb；默认：#696969
                        progressSelected: '#b53323',       //（可选项）字符串类型；滑动后的进度条背景色，支持#、rgb、rgba；默认：#76EE00
                        marginLeft: 1,       // (可选项) 数字类型；左边距，默认：5
                        marginRight: 1      // (可选项)数字类型；右边距，默认：5
                    },
                    totalTimeLabel: {
                        textSize: 10,                     //（可选项）数字类型；底部时间标签大小；默认：14
                        textColor: "#FFF",                //（可选项）字符串类型；底部时间标签颜色，支持#、rgba、rgb；默认：#FFF
                        textWidth: 40,                   //（可选项） 数字类型；时间标签的宽度
                        marginRight: 1                    // (可选项)数字类型；右边距，默认：5
                    },
                    fullscreenBtn: {
                        index: 1,
                        size: 23, //（可选项）数字类型；底部全屏/非全屏按钮大小；默认：44
                        verticalImg: 'widget://images/Player_img/go_full_screen.png',       //（可选项）字符串类型；底部横竖屏切换按钮的背景图片，竖屏状态下的切换按钮，要求本地路径（widget://、fs://）；默认：竖屏按钮图标
                        horizontalImg: 'widget://images/Player_img/Exit_full_screen.png',     //（可选项）字符串类型；底部横竖屏切换按钮的背景图片，横屏状态下的切换按钮，要求本地路径（widget://、fs://）；默认：横屏按钮图标
                    }

                }
            },

            path: json.path,//（可选项）文档的路径，支持网络和本地（fs://）路径，在 android 平台上不支持 widget
            autoPlay: true,//（可选项）打开时是否自动播放
            fixed: true,//（可选项）模块是否随所属 window 或 frame 滚动  默认值：true（不随之滚动）
            autorotation: false,//视频播放页面是否支持自动旋转（横竖屏），若为 false 则手动点击右下角按钮旋转
            // autorotation: true,//视频播放页面是否支持自动旋转（横竖屏），若为 false 则手动点击右下角按钮旋转
        }, function (ret, err) {
            console.log('moviePlayer_open.ret:' + JSON.stringify(ret));
            moviePlayer_keyback();
        });
        api.addEventListener({
            name: "hideVideo"
        }, function(){
            console.warn("moviePlayer")
            moviePlayer.hide();
        });
        api.addEventListener({
            name: "pauseVideo"
        }, function(){
            moviePlayer.pause();
        });
    }else {
        moviePlayer.replay({
            title:json.title,
            path : json.path,
        });
        moviePlayer.show();
    }
}

function moviePlayer_keyback() {

    // api.setFullScreen({fullScreen: true,});
    api.addEventListener({
        name: 'keyback'
    }, function (ret, err) {
        console.log('keyback');
        moviePlayer_back();
    });
    api.addEventListener({
        name: 'pause'
    }, function (ret, err) {
        console.log('pause');
        // moviePlayer_close();
        moviePlayer.pause();
    });
    /*  moviePlayer.addEventListener(function (ret) {
          if (ret && ret.eventType == 'back') {
              moviePlayer_back();
          }
      });*/
}

function moviePlayer_back() {
    //api.setFullScreen({fullScreen: false,});
    api.setScreenOrientation({
        orientation: 'portrait_up'
    });
    /*  moviePlayer.setShowOrHideControlView({
          isShow:true
      });*/
    moviePlayer.isFullscreen(function (ret, err) {
        console.log('isFullscreen' + jsonToStr(ret));
        if (ret.status) {
            moviePlayer_close();
        } else {
            closeWin();
        }
    });
}

function moviePlayer_close() {
    if (!is_app()) {
        return;
    }
    api.setScreenOrientation({
        orientation: 'portrait_up'
    });
    try {

        if (moviePlayer) {
            moviePlayer.hide();
        }
    } catch (e) {

    }
    /*  api.addEventListener({
          name: 'keyback'
      }, function (ret, err) {
          closeWin();
      });*/
}

