/**
 * Created by HASEE on 2017/4/21.
 */

function videoPlayer_play(json) {
    // console.log('videoPlayer:' + JSON.stringify(json));
    var videoPlayer = api.require('videoPlayer');
    videoPlayer.play({
            texts: {
                head: {
                    title: json.title || '',
                }
            },
            styles: {
                head: {                           //（可选项）JSON对象；播放器顶部导航条样式
                    bg: 'rgba(0,0,0,0.2)',  //（可选项）字符串类型；顶部导航条背景，支持#、rgb、rgba、img；默认：rgba(161,161,161,0.5)
                    height: 45,                   //（可选项）数字类型；顶部导航条的高；默认：44
                    titleSize: 12,                //（可选项）数字类型；顶部标题字体大小；默认：20
                    titleColor: '#fff',           //（可选项）字符串类型；顶部标题字体颜色；默认：#fff
                    backSize: 18,                 //（可选项）数字类型；顶部返回按钮大小；默认：44

                    backImg: 'widget://images/player/return.png',  //（可选项）字符串类型；顶部返回按钮的背景图片，要求本地路径（widget://、fs://）；默认：返回小箭头图标
                    setSize: 18,                  //（可选项）数字类型；顶部右边设置按钮大小；默认：44
                    // setImg:'fs://img/set.png'     //（可选项）字符串类型；顶部右边设置按钮背景图片，要求本地路径（widget://、fs://）；默认：设置小图标
                },
                foot: {                           //（可选项）JSON对象；播放器底部导航条样式
                    bg: 'rgba(0,0,0,0.2)',  //（可选项）字符串类型；底部导航条背景，支持#、rgb、rgba、img；默认：rgba(161,161,161,0.5)
                    height: 45,                   //（可选项）数字类型；底部导航条的高；默认：44
                    playSize: 21,                 //（可选项）数字类型；底部播放/暂停按钮大小；默认：44
                    playImg: 'widget://images/player/play2.png',  //（可选项）字符串类型；底部播放按钮的背景图片，要求本地路径（widget://、fs://）；默认：播放按钮图标
                    pauseImg: 'widget://images/player/pause.png', //（可选项）字符串类型；底部暂停按钮的背景图片，要求本地路径（widget://、fs://）；默认：暂停按钮图标
                    nextSize: 21,                 //（可选项）数字类型；底部下一集按钮大小；默认：44
                    nextImg: 'widget://images/player/no_btn.png',  //（可选项）字符串类型；底部下一集按钮的背景图片，要求本地路径（widget://、fs://）；默认：下一集按钮图标
                    timeSize: 12,                  //（可选项）数字类型；底部时间标签大小；默认：14
                    timeColor: '#fff',              //（可选项）字符串类型；底部时间标签颜色，支持#、rgba、rgb；默认：#fff
                    // sliderImg:'fs://img/slder.png',//（可选项）字符串类型；底部进度条滑块背景图片，要求本地路径（widget://、fs://）；默认：滑块小图标
                    progressColor: '#999999',      //（可选项）字符串类型；进度条背景色，支持#、rgba、rgb；默认：#696969
                    progressSelected: '#FFFFFF'    //（可选项）字符串类型；滑动后的进度条背景色，支持#、rgb、rgba；默认：#76EE00
                }
            },
            path: json.path, //（可选项）字符串类型；文档的路径，支持网络和本地（fs://）路径；默认：未传值时不播放
            //在 android 平台上不支持 widget://
            autoPlay: true, //（可选项）布尔类型；打开时是否自动播放；默认：true（自动播放）
            coverImg: json.coverImg || false,//类型：布尔 描述：（可选项）封面图路径，播放器打开尚未播放时的封面图，要求本地路径（widget://、fs://）
        },
        function (ret, err) {
            if (ret) {
                videoPlayer.setRect({
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 300
                    },
                    fullscreen: false,
                });
                console.log(JSON.stringify('videoPlayer.ret:' + jsonToStr(ret)));
            }
            if (err) {
                console.log(JSON.stringify('videoPlayer.err:' + jsonToStr(err)));
            }
        }
    )
    ;
}
// var orientation = 0;
function videoPlayer_open(json) {
    // console.log('videoPlayer:' + JSON.stringify(json));
    api.setScreenOrientation({orientation: "auto"});
    var videoPlayer = api.require("videoPlayer");
    videoPlayer.open({
        path: json.path,
        fixedOn: api.frameName,
        fixed:false,
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 100,
        }
    },function(ret, err) {
        if (ret.status) {
            console.log(JSON.stringify(ret));
        } else {
            console.log(JSON.stringify(err));
        }
    });
    videoPlayer.start();
    // orientation = window.orientation;
    window.addEventListener("orientationchange", function (e) {

        // orientation = window.orientation;
        videoPlayer.setRect({
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            }
        });
        api.setScreenOrientation({orientation: "auto"});
    }, false);
}
function InitEventListener() {
    api.addEventListener({
        name: 'PlayControl'
    }, function (ret, err) {
        switch (ret.value) {
            case 'start':
                videoPlayer.start();
                break;
            case 'pause':
                videoPlayer.pause();
                break;
            case 'fullScreen':
                api.setScreenOrientation({
                    orientation: 'landscape_right'
                });
                videoPlayer.setRect({
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    fullscreen: true
                });
                api.setFrameAttr({
                    name: 'idVideoPlayer',
                    rect: {
                        x: 0,
                        y: headerPos.h,
                        w: 'auto',
                        h: api.winWidth - headerPos.h
                    }
                });
                break;
            case 'cancelFullScreen':
                api.setScreenOrientation({
                    orientation: 'portrait_up'
                });
                videoPlayer.setRect({
                    rect: {
                        x: 0,
                        y: headerPos.h,
                        w: 'auto',
                        h: 230
                    },
                    fullscreen: false
                });
                api.setFrameAttr({
                    name: 'idVideoPlayer',
                    rect: {
                        x: 0,
                        y: headerPos.h,
                        w: 'auto',
                        h: 230
                    }
                });
                break;
        }
    });
}