function wx_shareWebpage(json) {
    console.log('wx_shareWebpage:' + jsonToStr(json));
    var wx = api.require('wxPlus');
    wx.isInstalled(function (ret, err) {
        console.log('wx_isInstalled_ret:' + jsonToStr(ret));
        console.log('wx_isInstalled_err:' + jsonToStr(err));
        if (ret.installed) {
            do_shareWebpage(json);
        } else {
            toastInfo('当前设备未安装微信客户端');
        }
    });

    function do_shareWebpage(json) {
        var shareImg = json.shareImg;
      if (shareImg) {
        app_download(shareImg, function (savePath) {
          shareWebpageCallback(savePath)
        });
      } else {
        shareWebpageCallback('');
      }


    }
    function shareWebpageCallback (savePath) {
      var wx = api.require('wxPlus');
      wx.shareWebpage({
        scene: json.scene || 'timeline', //session（会话）timeline（朋友圈）favorite（收藏）
        title: json.title || '厨艺宝',
        description: json.subTitle || '',
        thumb: savePath || 'widget://icon/200.png',
        contentUrl: json.contentUrl || 'http://youi-tech.com:8080/wang/html/video/homePage.html',
      }, function (ret, err) {
        console.log('shareWebpage.ret:' + JSON.stringify(ret));
        console.warn('shareWebpage.err:' + JSON.stringify(err));
        if (ret.status) {
          if (typeof json.callblack == "function") {
            json.callblack(ret);
          }
          toastInfo('微信分享成功!');
        } else {
          if (typeof json.err_callblack == "function") {
            json.err_callblack(err);
          }
        }
      });
    }
}


    function wx_shareIimg(json) {
        console.log('wx_share_img:' + jsonToStr(json));
        var wx = api.require('wxPlus');
        wx.isInstalled(function (ret, err) {
            console.log('wx_isInstalled_ret:' + jsonToStr(ret));
            console.log('wx_isInstalled_err:' + jsonToStr(err));
            if (ret.installed) {
                do_wx_share_img(json);
            } else {
                toastInfo('当前设备未安装微信客户端');
            }
        });

        function do_wx_share_img(json) {
            var EWM_img = json.contentUrl;
            var last_name = EWM_img.substr(EWM_img.lastIndexOf('/') + 1);
            var savePath = 'fs://Download/' + last_name;
            if (is_app()) {
                if(opWithPermission('storage', '需要获取存储权限用于保存图片，进行分享等操作')){
                    api.download({
                        url: EWM_img,
                        savePath: savePath,
                        report: true,
                        cache: false,
                        allowResume: true
                    }, function (ret) {
                        console.log('文件大小：' + ret.fileSize + '；下载进度：' + ret.percent + '；下载状态' + ret.state + '存储路径: ' + ret.savePath)
                        if (ret.state == 1) {
                            var wx = api.require('wxPlus');
                            wx.shareImage({
                                scene: json.scene || 'timeline', //session（会话）timeline（朋友圈）favorite（收藏）
                                thumb: 'widget://icon/icon.png',
                                contentUrl: savePath,
                            }, function (ret, err) {
                                console.log('wx_share_img.ret:' + JSON.stringify(ret));
                                console.warn('wx_share_img.err:' + JSON.stringify(err));
                                if (ret.status) {
                                    if (typeof json.callblack == "function") {
                                        json.callblack(ret);
                                    }
                                    toastInfo('微信分享成功!');
                                } else {
                                    if (typeof json.err_callblack == "function") {
                                        json.err_callblack(err);
                                    }
                                }
                            });
                        }
                    });
                }

            }
        }
    }


    function wx_login(callblack) {
        var wx_now_count = 0;
        //$api.setStorage('wx_now_count', 0);
        api.showProgress({
            title: '微信登录中',
            text: '请稍后',
        });
        var wx = api.require('wxPlus');

        wx.isInstalled(function (ret, err) {
            if (ret.installed) {
                auth();
            } else {
                alert('当前设备未安装微信客户端');
                api.closeWin();
            }
        });


        function auth() {
//  wx_toast('auth');
//    var wx = api.require('wxPlus');
            wx.auth({
                apiKey: ''
            }, function (ret, err) {
                if (ret.status) {
//      test('auth:'+ret.code);
//            wx_toast("当前设备已安装微信客户端");
//          return ret.code;
                    return getToken(ret.code);
                } else {
                    api.hideProgress();
                    if (err.code == 1) {
                        wx_toast('您取消微信登录授权');
                    } else if (err.code == 2) {
                        wx_toast('您拒绝微信登录授权');
                    } else if (err.code == 3) {
                        wx_toast('当前设备未安装微信客户端');
                    } else {
                        wx_toast('微信登录错误，请稍后重试');
                    }
                    ;
                    return false;
                }
            });
        }

//获取授权 accessToken（需要登录授权成功）

//{
//    status: true,      //布尔型；true||false
//        accessToken: '',   //字符串类型；接口调用凭证，传给 getUserInfo 接口 获取用户信息；有效期2小时
//    dynamicToken: '',  //字符串类型；当 accessToken 过期时把该值传给 refreshToken 接口刷新 accessToken 的有效期。dynamicToken 的有效期为30天
//    expires: 7200,     //数字类型；accessToken 有效期，单位（秒）
//    openId: ''         //字符串类型；授权用户唯一标识
//}
        function getToken(code) {
//  wx_toast('getToken');
            var now = 0;
            //var wx = api.require('wxPlus');
            wx.getToken({
                apiKey: '',
                apiSecret: '',
                code: code,
            }, function (ret, err) {
                if (ret.status) {
                    //alert(JSON.stringify(ret));
//          test('getToken:' + ret);
//          return ret;
                    return getUserInfo(ret);
                } else {
                    //now++;
                    var count = wx_count();
                    if (count) {
                        return getToken(code);
                    } else {
                        api.hideProgress();
                        return false;
                    }
                    //alert(err.code);
                }
            });
        }

//获取用户信息（需要获取 accessToken 成功）
//{
//    status: true,      //布尔型；true||false
//        openid: '',        //字符串类型；普通用户的标识，对当前开发者帐号唯一
//    nickname: '',      //字符串类型；普通用户昵称
//    sex: 1,            //数字类型；普通用户性别，1为男性，2为女性
//    headimgurl: '',    //字符串类型；用户头像，最后一个数值代表正方形头像大小（有0、46、64、96、132数值可选，0代表640*640正方形头像），用户没有头像时该项为空
//    privilege: [],     //数组类型；用户特权信息，如微信沃卡用户为（chinaunicom）
//    unionid: ''        //字符串类型；用户统一标识。针对一个微信开放平台帐号下的应用，同一用户的unionid是唯一的。
//}
        function getUserInfo(Token) {
//  wx_toast('getUserInfo');
//    var wx = api.require('wxPlus');
            wx.getUserInfo({
                accessToken: Token.accessToken,
                openId: Token.openId,
            }, function (ret, err) {
                if (ret.status) {
                    $api.setStorage('wx_data', ret);
                    wx_toast('微信登录成功');
                    if (typeof callblack == "function") {
                        return callblack(ret);
                    } else {
                        return ret;
                    }
                } else {
                    if (err.code == 1) {
                        return refreshToken(Token.dynamicToken)
                    } else {
                        var count = wx_count();
                        if (count) {
//                  do_wx();
                            return getUserInfo(Token);
                        } else {
                            api.hideProgress();
                            return false;
                        }
                    }
                }
            });
        }

        function refreshToken(dynamicToken) {
            //var wx = api.require('wxPlus');
            wx.refreshToken({
                apiKey: '',
                dynamicToken: dynamicToken,
            }, function (ret, err) {
                if (ret.status) {
                    return getUserInfo(ret);
                    //alert(JSON.stringify(ret));
                } else {
                    var count = wx_count();
                    if (count) {
                        do_wx();
                    } else {
                        api.hideProgress();
                        return false;
                    }
                }
            });
        }


//避免死循环
        function wx_count() {

            wx_now_count++;
            if (wx_now_count > 10) {
                return false;
            } else {
                api.hideProgress();
                wx_toast('微信登录错误，请稍后重试');
                return true;
            }
        }


    }


//弹出一个定时自动关闭的提示框
    function wx_toast(infoStr) {
        api.toast({
            msg: infoStr,
            duration: 5000,//持续时长，单位：毫秒
            location: 'middle',//top 顶部  middle 中间  bottom 底部
            global: false,//是否是全局的toast。若为false，toast将只在当前window范围可见；若为true，安卓手机上面弹出的位置将会固定在底部区域。
        });
    }
